// TODO: Prolog?
define( [ "dojo/_base/declare",
          "dijit/TooltipDialog",
          "dojo/dom-construct",
					"dojo/dom-geometry",
					"dojo/dom-style",
					"dojo/dom-class",
					"dojo/dom-attr",
					"dojo/query",
					"dojo/on",
					"dojo/_base/lang" ],
					function( declare, TooltipDialog, domConst, domGeo, domStyle, domClass, domAttr, $, on, lang ){
						
	 return declare( "ModelTooltip", TooltipDialog, {

   _aroundNodeCoords: null,
	 
   orient: function(/*DomNode*/ node, /*String*/ aroundCorner, /*String*/ tooltipCorner, /*Object*/ spaceAvailable, /*Object*/ aroundNodeCoords){
		  var box, parentBox;
			// summary:
			//		Private function to set CSS for tooltip node based on which position it's in.
			//		This is called by the dijit popup code.   It will also reduce the tooltip's
			//		width to whatever width is available
			// tags:
			//		protected

			var newC = "dijitTooltip " +
				{
					"MR-ML": "dijitTooltipRight",
					"TR-TL": "dijitTooltipRight",
					"ML-MR": "dijitTooltipLeft",
					"TM-BM": "dijitTooltipAbove",
					"BM-TM": "dijitTooltipBelow",
					"BL-TL": "dijitTooltipBelow dijitTooltipABLeft",
					"TL-BL": "dijitTooltipAbove dijitTooltipABLeft",
					"TL-TR": "dijitTooltipLeft",
					"BR-TR": "dijitTooltipBelow dijitTooltipABRight",
					"TR-BR": "dijitTooltipAbove dijitTooltipABRight",
					"BR-BL": "dijitTooltipRight",
					"BL-BR": "dijitTooltipLeft"
				}[aroundCorner + "-" + tooltipCorner], nodeCoords = aroundNodeCoords || this._aroundNodeCoords;

			 domClass.replace(this.domNode, newC, this._currentOrientClass || "");
			 this._currentOrientClass = newC;
			 
			 var arrow = $( ".dijitTooltipConnector", node )[0], arrowBox = domGeo.getContentBox( arrow );
						 
			 switch( aroundCorner + "-" + tooltipCorner ){
					case "TR-TL":
						 domStyle.set( arrow, "top", ( (nodeCoords.h/2) - (arrowBox.h/2) ) + "px" );
						 break;
					case "BR-TR":
						 domStyle.set( arrow, "right", ( (nodeCoords.w/2) - (arrowBox.w/2) ) + "px" );
						 
					   if( this.domNode === node ){
							 box = domGeo.getMarginBox( node );
							 parentBox = domGeo.getMarginBox( node.parentNode );
							 domStyle.set( this.domNode.parentNode, "left", ( parentBox.l - box.w ) + "px" );
						 }
						 break;
					case "BL-TL":
					   domStyle.set( arrow, "left", ( (nodeCoords.w/2) - (arrowBox.w/2) ) + "px" );
						 break;
				  case "TL-TR":
						domStyle.set( arrow, "top", ( (nodeCoords.h/2) - (arrowBox.h/2) ) + "px" );
						
						if( this.domNode === node ){
							 box = domGeo.getMarginBox( node );
							 parentBox = domGeo.getMarginBox( node.parentNode );
							 domStyle.set( this.domNode.parentNode, "left", ( parentBox.l - box.w ) + "px" );
						 }
						 break;
          case "TL-BL":
					  domStyle.set( arrow, "left", ( (nodeCoords.w/2) - (arrowBox.w/2) ) + "px" );

						if( this.domNode === node ){
							 box = domGeo.getMarginBox( node );
							 parentBox = domGeo.getMarginBox( node.parentNode );
							 domStyle.set( this.domNode.parentNode, "top", ( parentBox.t - box.h ) + "px" );
						 }
						 break;
						 
					case "TR-BR":
						 domStyle.set( arrow, "right", ( (nodeCoords.w/2) - (arrowBox.w/2) ) + "px" );

	 					 if( this.domNode === node ){
							 box = domGeo.getMarginBox( node );
							 parentBox = domGeo.getMarginBox( node.parentNode );
							 domStyle.set( this.domNode.parentNode, "top", ( parentBox.t - box.h ) + "px" );
 							 domStyle.set( this.domNode.parentNode, "left", ( parentBox.l - box.w ) + "px" );
						 }
						 break;

           

			 }
			 
			 /* This method gets called twice, the first time aroundNodeCoords is an object, the second time it undefined.
			    However, on the first call the arrow is hidden, thus the content box is 0.  The arrow position is off, so
					save the aroundNodeCoords for the second round to correctly align the arrow.  */

			 this._aroundNodeCoords = aroundNodeCoords || null;

			}		


	} ); // declare
  
}); //